
#pragma once

namespace Box2DLib
{
	DEFINE_STRUCT( b2BodyDef )
	{
		DEFINE_STRUCT_SET( b2BodyDef );
		
		DEFINE_PROPERTY_B( b2MassData, massData );
		DEFINE_PROPERTY_C( IntPtr, userData, static_cast<IntPtr>, static_cast<void*> );
		DEFINE_PROPERTY_V_CODE( int, userDataInt, { return reinterpret_cast<int>(BASEMEMBER(userData)); }, { BASEMEMBER(userData) = reinterpret_cast<void *>(v); } );

		DEFINE_PROPERTY_B( b2Vec2, position );
		DEFINE_PROPERTY_V( float32, angle );
		DEFINE_PROPERTY_V( float32, linearDamping );
		DEFINE_PROPERTY_V( float32, angularDamping );
		DEFINE_PROPERTY_V( bool, allowSleep );
		DEFINE_PROPERTY_V( bool, isSleeping );
		DEFINE_PROPERTY_V( bool, fixedRotation );
		DEFINE_PROPERTY_V( bool, isBullet );
	};

	DEFINE_STRUCT_PROTOTYPE( b2World );

	DEFINE_STRUCT( b2Body )
	{
		DEFINE_CONSTRUCTOR_WRAPPER( b2Body );
		DEFINE_BASEACCESS( b2Body );
		DEFINE_COPYMETHOD( b2Body );
		DEFINE_DELETEBASE_DUMMY();
		
		DEFINE_METHOD( P, b2Shape, CreateShape, P, (b2ShapeDef) );
		DEFINE_METHOD( N, void, DestroyShape, P, (b2Shape) );
		DEFINE_METHOD( N, void, SetMass, P, (b2MassData) );
		DEFINE_METHOD( N, void, SetMassFromShapes, N, () );
		DEFINE_METHOD( V, bool, SetXForm, BV, (b2Vec2, float32) );
		DEFINE_METHOD( B, b2XForm, GetXForm, N, () );
		DEFINE_METHOD( B, b2Vec2, GetPosition, N, () );
		DEFINE_METHOD( V, float32, GetAngle, N, () );
		DEFINE_METHOD( B, b2Vec2, GetWorldCenter, N, () );
		DEFINE_METHOD( B, b2Vec2, GetLocalCenter, N, () );
		DEFINE_METHOD( N, void, SetLinearVelocity, B, (b2Vec2) );
		DEFINE_METHOD( B, b2Vec2, GetLinearVelocity, N, () );
		DEFINE_METHOD( N, void, SetAngularVelocity, V, (float32) );
		DEFINE_METHOD( V, float32, GetAngularVelocity, N, () );
		DEFINE_METHOD( N, void, ApplyForce, BB, (b2Vec2, b2Vec2) );
		DEFINE_METHOD( N, void, ApplyTorque, V, (float32) );
		DEFINE_METHOD( N, void, ApplyImpulse, BB, (b2Vec2, b2Vec2) );
		DEFINE_METHOD( V, float32, GetMass, N, () );
		DEFINE_METHOD( V, float32, GetInertia, N, () );
		DEFINE_METHOD( B, b2Vec2, GetWorldPoint, B, (b2Vec2) );
		DEFINE_METHOD( B, b2Vec2, GetWorldVector, B, (b2Vec2) );
		DEFINE_METHOD( B, b2Vec2, GetLocalPoint, B, (b2Vec2) );
		DEFINE_METHOD( B, b2Vec2, GetLocalVector, B, (b2Vec2) );
		DEFINE_METHOD( B, b2Vec2, GetLinearVelocityFromWorldPoint, B, (b2Vec2) );
		DEFINE_METHOD( B, b2Vec2, GetLinearVelocityFromLocalPoint, B, (b2Vec2) );
		DEFINE_METHOD( V, bool, IsBullet, N, () );
		DEFINE_METHOD( N, void, SetBullet, V, (bool) );
		DEFINE_METHOD( V, bool, IsStatic, N, () );
		DEFINE_METHOD( V, bool, IsDynamic, N, () );
		DEFINE_METHOD( V, bool, IsFrozen, N, () );
		DEFINE_METHOD( V, bool, IsSleeping, N, () );
		DEFINE_METHOD( N, void, AllowSleeping, V, (bool) );
		DEFINE_METHOD( N, void, WakeUp, N, () );
		DEFINE_METHOD( N, void, PutToSleep, N, () );

		DEFINE_METHOD( P, b2Shape, GetShapeList, N, () );
		// ToDo : b2JointEdge* GetJointList();
		//DEFINE_METHOD( P, b2JointEdge, GetJointList, N, () );

		DEFINE_METHOD( P, b2Body, GetNext, N, () );

		DEFINE_METHOD( C, IntPtr, GetUserData, N, () );
		DEFINE_METHOD( N, void, SetUserData, I, (IntPtr) );
		DEFINE_PROPERTY_V_CODE( int, userDataInt, { return reinterpret_cast<int>(BASEMEMBER(GetUserData)()); }, { BASEMEMBER(SetUserData)( reinterpret_cast<void *>(v) ); } );

		// ToDo : b2World* GetWorld();
		DEFINE_METHOD_DECLARE( P, b2World, GetWorld, N, () );

	};

	DEFINE_CLASSMETHOD( b2Shape, P, b2Body, GetBody, N, () );
}
