#pragma once

namespace Box2DLib
{
	DEFINE_STRUCT( b2ContactID )
	{
		DEFINE_STRUCT_SET( b2ContactID );
		
		DEFINE_PROPERTY_V( uint32, key );
		
		DEFINE_PROPERTY_V_CODE( uint8, referenceEdge,	{ return BASEMEMBER(features).referenceEdge; },		{ BASEMEMBER(features).referenceEdge = v; }		);
		DEFINE_PROPERTY_V_CODE( uint8, incidentEdge,	{ return BASEMEMBER(features).incidentEdge; },		{ BASEMEMBER(features).incidentEdge = v; }		);
		DEFINE_PROPERTY_V_CODE( uint8, incidentVertex,	{ return BASEMEMBER(features).incidentVertex; },	{ BASEMEMBER(features).incidentVertex = v; }	);
		DEFINE_PROPERTY_V_CODE( uint8, flip,			{ return BASEMEMBER(features).flip; },				{ BASEMEMBER(features).flip = v; }				);
	};

	DEFINE_STRUCT( b2ManifoldPoint )
	{
		DEFINE_STRUCT_SET( b2ManifoldPoint );

		DEFINE_PROPERTY_B( b2Vec2, localPoint1 );
		DEFINE_PROPERTY_B( b2Vec2, localPoint2 );
		DEFINE_PROPERTY_V( float32, separation );
		DEFINE_PROPERTY_V( float32, normalImpulse );
		DEFINE_PROPERTY_V( float32, tangentImpulse );
		DEFINE_PROPERTY_B( b2ContactID, id );
	};

	DEFINE_STRUCT( b2Manifold )
	{
		DEFINE_STRUCT_SET( b2Manifold );

		DEFINE_PROPERTY_BA( b2ManifoldPoint, points, b2_maxManifoldPoints );

		DEFINE_PROPERTY_B( b2Vec2, normal );
		DEFINE_PROPERTY_V( int32, pointCount );
	};

	DEFINE_STRUCT( b2Segment )
	{
		DEFINE_STRUCT_SET( b2Segment );

		// ToDo : bool TestSegment(float32* lambda, b2Vec2* normal, const b2Segment& segment, float32 maxLambda) const;

		DEFINE_PROPERTY_B( b2Vec2, p1 );
		DEFINE_PROPERTY_B( b2Vec2, p2 );
	};

	
	DEFINE_STRUCT( b2AABB )
	{
		DEFINE_STRUCT_SET( b2AABB );

		DEFINE_METHOD( V, bool, IsValid, N, () );
		
		DEFINE_PROPERTY_B( b2Vec2, lowerBound );
		DEFINE_PROPERTY_B( b2Vec2, upperBound );
	};

	DEFINE_STRUCT( b2OBB )
	{
		DEFINE_STRUCT_SET( b2OBB );

		DEFINE_PROPERTY_B( b2Mat22, R );
		DEFINE_PROPERTY_B( b2Vec2, center );
		DEFINE_PROPERTY_B( b2Vec2, extents );
	};

	// ToDo : void b2CollideCircles(b2Manifold* manifold, const b2CircleShape* circle1, const b2XForm& xf1, const b2CircleShape* circle2, const b2XForm& xf2);
	// ToDo : void b2CollidePolygonAndCircle(b2Manifold* manifold, const b2PolygonShape* polygon, const b2XForm& xf1, const b2CircleShape* circle, const b2XForm& xf2);
	// ToDo : void b2CollidePolygons(b2Manifold* manifold, const b2PolygonShape* polygon1, const b2XForm& xf1, const b2PolygonShape* polygon2, const b2XForm& xf2);
	// ToDo : float32 b2Distance(b2Vec2* x1, b2Vec2* x2, const b2Shape* shape1, const b2XForm& xf1, const b2Shape* shape2, const b2XForm& xf2);
	// ToDo : float32 b2TimeOfImpact(const b2Shape* shape1, const b2Sweep& sweep1, const b2Shape* shape2, const b2Sweep& sweep2);

	// ToDo : inline bool b2TestOverlap(const b2AABB& a, const b2AABB& b)

}
