
#pragma once

namespace Box2DLib
{

	DEFINE_STRUCT_INHERIT( b2DistanceJointDef, b2JointDef )
	{
		DEFINE_STRUCT_SET( b2DistanceJointDef );

		DEFINE_METHOD( N, void, Initialize, PPBB, (b2Body, b2Body, b2Vec2, b2Vec2) );

		DEFINE_PROPERTY_B( b2Vec2, localAnchor1 );
		DEFINE_PROPERTY_B( b2Vec2, localAnchor2 );
		DEFINE_PROPERTY_V( float32, length );
		DEFINE_PROPERTY_V( float32, frequencyHz );
		DEFINE_PROPERTY_V( float32, dampingRatio );

	};

	DEFINE_STRUCT_INHERIT( b2DistanceJoint, b2Joint )
	{
		DEFINE_CONSTRUCTOR_WRAPPERINHERIT( b2DistanceJoint, b2Joint );
		DEFINE_BASEACCESS( b2DistanceJoint );
		DEFINE_COPYMETHOD( b2DistanceJoint );
		DEFINE_CASTMETHOD( b2DistanceJoint, b2Joint );

		DEFINE_METHOD_OVERRIDE( B, b2Vec2, GetAnchor1, N, () );
		DEFINE_METHOD_OVERRIDE( B, b2Vec2, GetAnchor2, N, () );

		DEFINE_METHOD_OVERRIDE( B, b2Vec2, GetReactionForce, N, () );
		DEFINE_METHOD_OVERRIDE( V, float32, GetReactionTorque, N, () );
	};

}
