
#pragma once

namespace Box2DLib
{

	DEFINE_STRUCT_INHERIT( b2MouseJointDef, b2JointDef )
	{
		DEFINE_STRUCT_SET( b2MouseJointDef );

		DEFINE_PROPERTY_B( b2Vec2, target );
		DEFINE_PROPERTY_V( float32, maxForce );
		DEFINE_PROPERTY_V( float32, frequencyHz );
		DEFINE_PROPERTY_V( float32, dampingRatio );
		DEFINE_PROPERTY_V( float32, timeStep );
	};

	DEFINE_STRUCT_INHERIT( b2MouseJoint, b2Joint )
	{
		DEFINE_CONSTRUCTOR_WRAPPERINHERIT( b2MouseJoint, b2Joint );
		DEFINE_BASEACCESS( b2MouseJoint );
		DEFINE_COPYMETHOD( b2MouseJoint );
		DEFINE_CASTMETHOD( b2MouseJoint, b2Joint );

		DEFINE_METHOD_OVERRIDE( B, b2Vec2, GetAnchor1, N, () );
		DEFINE_METHOD_OVERRIDE( B, b2Vec2, GetAnchor2, N, () );

		DEFINE_METHOD_OVERRIDE( B, b2Vec2, GetReactionForce, N, () );
		DEFINE_METHOD_OVERRIDE( V, float32, GetReactionTorque, N, () );

		DEFINE_METHOD( N, void, SetTarget, B, (b2Vec2) );
	};

}
