
#pragma once

namespace Box2DLib
{
	DEFINE_STRUCT_INHERIT( b2PolygonDef, b2ShapeDef )
	{
		DEFINE_STRUCT_SET( b2PolygonDef );

		DEFINE_METHOD( N, void, SetAsBox, VV, (float32, float32) );
		DEFINE_METHOD( N, void, SetAsBox, VVBV, (float32, float32, b2Vec2, float32) );

		DEFINE_PROPERTY_BA( b2Vec2, vertices, b2_maxPolygonVertices );
		DEFINE_PROPERTY_V( int32, vertexCount );
	};

	DEFINE_STRUCT_INHERIT( b2PolygonShape, b2Shape )
	{
		DEFINE_CONSTRUCTOR_WRAPPERINHERIT( b2PolygonShape, b2Shape );
		DEFINE_BASEACCESS( b2PolygonShape );
		DEFINE_COPYMETHOD( b2PolygonShape );
		DEFINE_CASTMETHOD( b2PolygonShape, b2Shape );

		DEFINE_METHOD_OVERRIDE( V, bool, TestPoint, BB, (b2XForm, b2Vec2) );
		// ToDo : virtual bool TestSegment(	const b2XForm& xf, float32* lambda, b2Vec2* normal, const b2Segment& segment, float32 maxLambda) const;
		DEFINE_METHOD_OVERRIDE( N, void, ComputeAABB, PB, (b2AABB, b2XForm) );
		DEFINE_METHOD_OVERRIDE( N, void, ComputeSweptAABB, PBB, (b2AABB, b2XForm, b2XForm) );
		DEFINE_METHOD_OVERRIDE( N, void, ComputeMass, P, (b2MassData) );

		DEFINE_METHOD( B, b2OBB, GetOBB, N, () );
		DEFINE_METHOD( B, b2Vec2, GetCentroid, N, () );
		DEFINE_METHOD( V, int32, GetVertexCount, N, () );

		// ToDo : const b2Vec2* GetVertices() const;
		DEFINE_PROPERTY_BA_CODE( b2Vec2, Vertices, b2_maxPolygonVertices, BASEMEMBER(GetVertices())[ Index ] );
		// ToDo : const b2Vec2* GetCoreVertices() const;
		DEFINE_PROPERTY_BA_CODE( b2Vec2, Normals, b2_maxPolygonVertices, BASEMEMBER(GetNormals())[ Index ] );
		// ToDo : const b2Vec2* GetNormals() const;
		DEFINE_PROPERTY_BA_CODE( b2Vec2, CoreVertices, b2_maxPolygonVertices, BASEMEMBER(GetCoreVertices())[ Index ] );

		DEFINE_METHOD( B, b2Vec2, GetFirstVertex, B, (b2XForm) );
		DEFINE_METHOD( B, b2Vec2, Centroid, B, (b2XForm) );
		DEFINE_METHOD( B, b2Vec2, Support, BB, (b2XForm, b2Vec2) );
	};


}
