
#pragma once

namespace Box2DLib
{

	DEFINE_STRUCT_INHERIT( b2PrismaticJointDef, b2JointDef )
	{
		DEFINE_STRUCT_SET( b2PrismaticJointDef );

		DEFINE_METHOD( N, void, Initialize, PPBB, (b2Body, b2Body, b2Vec2, b2Vec2) );

		DEFINE_PROPERTY_B( b2Vec2, localAnchor1 );
		DEFINE_PROPERTY_B( b2Vec2, localAnchor2 );
		DEFINE_PROPERTY_B( b2Vec2, localAxis1 );
		DEFINE_PROPERTY_V( float32, referenceAngle );
		DEFINE_PROPERTY_V( bool, enableLimit );
		DEFINE_PROPERTY_V( float32, lowerTranslation );
		DEFINE_PROPERTY_V( float32, upperTranslation );
		DEFINE_PROPERTY_V( bool, enableMotor );
		DEFINE_PROPERTY_V( float32, maxMotorForce );
		DEFINE_PROPERTY_V( float32, motorSpeed );
	};

	DEFINE_STRUCT_INHERIT( b2PrismaticJoint, b2Joint )
	{
		DEFINE_CONSTRUCTOR_WRAPPERINHERIT( b2PrismaticJoint, b2Joint );
		DEFINE_BASEACCESS( b2PrismaticJoint );
		DEFINE_COPYMETHOD( b2PrismaticJoint );
		DEFINE_CASTMETHOD( b2PrismaticJoint, b2Joint );

		DEFINE_METHOD_OVERRIDE( B, b2Vec2, GetAnchor1, N, () );
		DEFINE_METHOD_OVERRIDE( B, b2Vec2, GetAnchor2, N, () );

		DEFINE_METHOD_OVERRIDE( B, b2Vec2, GetReactionForce, N, () );
		DEFINE_METHOD_OVERRIDE( V, float32, GetReactionTorque, N, () );

		DEFINE_METHOD( V, float32, GetJointTranslation, N, () );
		DEFINE_METHOD( V, float32, GetJointSpeed, N, () );
		DEFINE_METHOD( V, bool, IsLimitEnabled, N, () );
		DEFINE_METHOD( N, void, EnableLimit, V, (bool) );
		DEFINE_METHOD( V, float32, GetLowerLimit, N, () );
		DEFINE_METHOD( V, float32, GetUpperLimit, N, () );
		DEFINE_METHOD( N, void, SetLimits, VV, (float32, float32) );
		DEFINE_METHOD( V, bool, IsMotorEnabled, N, () );
		DEFINE_METHOD( N, void, EnableMotor, V, (bool) );
		DEFINE_METHOD( N, void, SetMotorSpeed, V, (float32) );
		DEFINE_METHOD( V, float32, GetMotorSpeed, N, () );
		DEFINE_METHOD( N, void, SetMaxMotorForce, V, (float32) );
		DEFINE_METHOD( V, float32, GetMotorForce, N, () );

	};

}
