
#pragma once

namespace Box2DLib
{

	DEFINE_STRUCT_INHERIT( b2PulleyJointDef, b2JointDef )
	{
		DEFINE_STRUCT_SET( b2PulleyJointDef );

		DEFINE_METHOD( N, void, Initialize, PPBBBBV, (b2Body, b2Body, b2Vec2, b2Vec2, b2Vec2, b2Vec2, float32) );

		DEFINE_PROPERTY_B( b2Vec2, groundAnchor1 );
		DEFINE_PROPERTY_B( b2Vec2, groundAnchor2 );
		DEFINE_PROPERTY_B( b2Vec2, localAnchor1 );
		DEFINE_PROPERTY_B( b2Vec2, localAnchor2 );
		DEFINE_PROPERTY_V( float32, length1 );
		DEFINE_PROPERTY_V( float32, maxLength1 );
		DEFINE_PROPERTY_V( float32, length2 );
		DEFINE_PROPERTY_V( float32, maxLength2 );
		DEFINE_PROPERTY_V( float32, ratio );
	};

	DEFINE_STRUCT_INHERIT( b2PulleyJoint, b2Joint )
	{
		DEFINE_CONSTRUCTOR_WRAPPERINHERIT( b2PulleyJoint, b2Joint );
		DEFINE_BASEACCESS( b2PulleyJoint );
		DEFINE_COPYMETHOD( b2PulleyJoint );
		DEFINE_CASTMETHOD( b2PulleyJoint, b2Joint );

		DEFINE_METHOD_OVERRIDE( B, b2Vec2, GetAnchor1, N, () );
		DEFINE_METHOD_OVERRIDE( B, b2Vec2, GetAnchor2, N, () );

		DEFINE_METHOD_OVERRIDE( B, b2Vec2, GetReactionForce, N, () );
		DEFINE_METHOD_OVERRIDE( V, float32, GetReactionTorque, N, () );

		DEFINE_METHOD( B, b2Vec2, GetGroundAnchor1, N, () );
		DEFINE_METHOD( B, b2Vec2, GetGroundAnchor2, N, () );

		DEFINE_METHOD( V, float32, GetLength1, N, () );
		DEFINE_METHOD( V, float32, GetLength2, N, () );
		DEFINE_METHOD( V, float32, GetRatio, N, () );
	};

}
