#pragma once

namespace Box2DLib
{
	DEFINE_STRUCT( b2Version )
	{
		DEFINE_STRUCT_SET( b2Version )

		DEFINE_PROPERTY_V( int32, major );
		DEFINE_PROPERTY_V( int32, minor );
		DEFINE_PROPERTY_V( int32, revision );

		DEFINE_TOSTRING(( "{{ {0}.{1}.{2} }}", BASEMEMBER(major), BASEMEMBER(minor), BASEMEMBER(revision) )); 
	};

	DEFINE_STATIC( Settings )
	{
		DEFINE_CONST( float32, b2_pi )

		DEFINE_CONST( int32, b2_maxManifoldPoints )
		DEFINE_CONST( int32, b2_maxPolygonVertices )
		DEFINE_CONST( int32, b2_maxProxies )
		DEFINE_CONST( int32, b2_maxPairs )

		DEFINE_CONST( float32, b2_linearSlop )
		DEFINE_CONST( float32, b2_angularSlop )
		DEFINE_CONST( float32, b2_toiSlop )
		DEFINE_CONST( int32, b2_maxTOIContactsPerIsland )
		DEFINE_CONST( float32, b2_velocityThreshold )
		DEFINE_CONST( float32, b2_maxLinearCorrection )
		DEFINE_CONST( float32, b2_maxAngularCorrection )

		DEFINE_CONST( float32, b2_maxAngularVelocity )

		DEFINE_CONST( float32, b2_contactBaumgarte )

		DEFINE_CONST( float32, b2_timeToSleep )
		DEFINE_CONST( float32, b2_linearSleepTolerance )
		DEFINE_CONST( float32, b2_angularSleepTolerance )

		static property int32 b2_byteCount
		{
			int32 get()				{ return UNAME(b2_byteCount); }
			void set( int32 v )		{ UNAME(b2_byteCount) = v; }
		}

		static property MNAME(b2Version)^ b2_version
		{
			MNAME(b2Version)^ get()		{ return gcnew MNAME(b2Version)( (UNAME(b2Version) *)&(::b2_version) ); }
		}
	};


}
